package com.inca.npbusi.sales.bms_group_sa_doc;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.npbusi.saHelper.SaCalcRate;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.PresHelper;
import com.inca.pubsrv.hov.bms_tr_pos_hov.Bms_tr_pos_hov;
import com.inca.pubsrv.hov.pub_custom_to_saler_hov.Pub_custom_to_saler_hov;
import java.awt.BorderLayout;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class Bms_sales_master extends CMasterModel {
   public Bms_sales_master(CFrame var1, CMdeModel var2) {
      super(var1, "销售发货单总单", var2);
   }

   public String getTablename() {
      return "bms_group_sa_doc_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected JPanel createSecondtoolbar() {
      JPanel var1 = new JPanel();
      CToolbar var2 = new CToolbar();
      var1.setLayout(new BorderLayout());
      var1.add(var2);
      return NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(NpbusiDBHelper.createTButton(var1, "确定(C)", "确定", "确定", 67, this.mdemodel), "回退提交(T)", "回退提交", "回退提交", 84, this.mdemodel), "审批(P)", "审批", "审批", 80, this.mdemodel), "回退确定(B)", "回退确定", "回退确定", 66, this.mdemodel), "作废(I)", "作废", "作废", 73, this.mdemodel), "生成发票(V)", "生成发票", "生成发票", 86, this.mdemodel), "切换独立单元(A)", "切换独立单元", "切换独立单元", 65, this.mdemodel);
   }

   protected int on_beforeNew() {
      if (this.getModifiedDbmodel().getRowCount() > 0) {
         this.infoMessage("警告", "请先保存数据！");
         return -1;
      } else {
         String var1;
         if ((var1 = ((Bms_sales_mde)this.mdemodel).getEntryid()) != null && !var1.equals("")) {
            String var2 = ((Bms_sales_mde)this.mdemodel).getApvalue("授权独立单元");
            String var3 = ((Bms_sales_mde)this.mdemodel).getEntryname();
            if (var2.equals(var1)) {
               this.infoMessage("提示", "当前独立单元为:" + var3 + "\n要求当前独立单元跟您授权的独立单元不同才可以开票，您可以切换独立单元;");
               return -1;
            } else {
               var1 = ClientUserManager.getCurrentUser().getDeptid();
               if (!this.a(var1)) {
                  this.infoMessage("提示", "当前的销售部门不是进货部门，不允许开票!");
                  return -1;
               } else {
                  return super.on_beforeNew();
               }
            }
         } else {
            this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能录入单据！");
            return -1;
         }
      }
   }

   private boolean a(String var1) {
      var1 = " select 1 from pub_dept_supply v where v.sudeptid=" + var1;
      RemotesqlHelper var2 = new RemotesqlHelper();

      try {
         DBTableModel var4;
         return (var4 = var2.doSelect(var1, 0, 1)) != null && var4.getRowCount() != 0;
      } catch (Exception var3) {
         var3.printStackTrace();
         this.infoMessage("提示", "检查当前销售部门是否为进货部门时出错;");
         return false;
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if (var2.equals("delivermethod")) {
         if ("0".equals(var3)) {
            this.setItemValue(var1, "targetposopcode", "");
            this.setItemValue(var1, "targetposid", "");
            this.setItemValue(var1, "targetname", "");
         } else if ("1".equals(var3)) {
            this.setItemValue(var1, "midposopcode", "");
            this.setItemValue(var1, "midposid", "");
            this.setItemValue(var1, "midposname", "");
         } else {
            this.setItemValue(var1, "midposopcode", "");
            this.setItemValue(var1, "targetposopcode", "");
         }
      } else if ("customid".equals(var2) && var3 != null) {
         String var4 = ClientUserManager.getCurrentUser().getEntryid();
         var4 = "select lowpriceflag,delivermethod from pub_company_to_definfo where companyid = " + var3 + " and ( entryid = " + var4 + " or entryid is null) order by entryid";
         RemotesqlHelper var5 = new RemotesqlHelper();

         try {
            DBTableModel var7;
            if ((var7 = var5.doSelect(var4, 0, 1)) != null && var7.getRowCount() != 0) {
               this.setItemValue(var1, "delivermethod", "");
               this.setItemValue(var1, "lowpriceflag", "");
               this.setItemValue(var1, "delivermethod", var7.getItemValue(0, "delivermethod"));
               this.setItemValue(var1, "lowpriceflag", var7.getItemValue(0, "lowpriceflag"));
            } else {
               this.setItemValue(var1, "delivermethod", "");
               this.setItemValue(var1, "lowpriceflag", "");
            }
         } catch (Exception var6) {
            var6.printStackTrace();
            this.infoMessage("提示", "检查客户管理，客户管理查询出错;");
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   public int on_hov(int var1, String var2, DBTableModel var3) {
      if (var2.equals("customopcode")) {
         if (!this.getItemValue(var1, "agentid").equals("")) {
            this.setItemValue(var1, "agentid", "");
            this.setItemValue(var1, "agentopcode", "");
            this.setItemValue(var1, "agentname", "");
         }

         String var4;
         if ((var4 = var3.getItemValue(0, "customid")) == null || var4.equals("")) {
            return -1;
         }

         RemotesqlHelper var6 = new RemotesqlHelper();
         DBTableModel var7 = null;
         String var8;
         if ((var8 = this.getItemValue(var1, "entryid")) == null || var8.equals("")) {
            this.infoMessage("提示", "没有独立单元，不可录入总单！");
            this.setItemValue(var1, "customopcode", "");
            this.setItemValue(var1, "customid", "");
            this.setItemValue(var1, "saleropcode", "");
            this.setItemValue(var1, "salesdeptname", "");
            this.setItemValue(var1, "salerid", "");
            this.setItemValue(var1, "salesdeptid", "");
            this.setItemValue(var1, "salername", "");
            this.setItemValue(var1, "customname", "");
            return -1;
         }

         String var5 = "select * from pub_custom_to_saler_v where customid=" + var4 + " and  entryid=" + var8;

         try {
            var7 = var6.doSelect(var5, 0, 10);
         } catch (Exception var17) {
            var17.printStackTrace();
         }

         if (var7 == null || var7.getRowCount() <= 0) {
            this.infoMessage("提示", "没有当前独立单元业务员，不可录入总单！");
            this.setItemValue(var1, "customopcode", "");
            this.setItemValue(var1, "customid", "");
            this.setItemValue(var1, "saleropcode", "");
            this.setItemValue(var1, "salesdeptname", "");
            this.setItemValue(var1, "salerid", "");
            this.setItemValue(var1, "salesdeptid", "");
            this.setItemValue(var1, "salername", "");
            this.setItemValue(var1, "customname", "");
            return -1;
         }

         String var9;
         String var10;
         String var11;
         String var12;
         String var13;
         DBTableModel var20;
         if (var7.getRowCount() != 1) {
            Pub_custom_to_saler_hov var19;
            (var19 = new Pub_custom_to_saler_hov(true)).setOtherwheres("customid = " + var4);
            if ((var20 = var19.showDialog(this.frame, "")) == null) {
               this.setItemValue(var1, "salerid", "");
               this.setItemValue(var1, "saleropcode", "");
               this.setItemValue(var1, "salername", "");
               this.setItemValue(var1, "salesdeptname", "");
               this.setItemValue(var1, "salesdeptid", "");
            } else {
               var11 = var20.getItemValue(0, "salerid");
               var12 = var20.getItemValue(0, "saleropcode");
               var5 = var20.getItemValue(0, "salername");
               var13 = var20.getItemValue(0, "salerdeptname");
               var10 = var20.getItemValue(0, "salerdeptid");
               this.setItemValue(var1, "salerid", var11);
               this.setItemValue(var1, "saleropcode", var12);
               this.setItemValue(var1, "salername", var5);
               this.setItemValue(var1, "salesdeptname", var13);
               this.setItemValue(var1, "salesdeptid", var10);
            }
         } else {
            var9 = var7.getItemValue(0, "salerdeptid");
            var10 = var7.getItemValue(0, "salerid");
            var11 = var7.getItemValue(0, "saleropcode");
            var12 = var7.getItemValue(0, "salername");
            var5 = var7.getItemValue(0, "salerdeptname");
            if (var9 == null || "".equals(var9)) {
               var5 = "select * from pub_employee_v where employeeid=" + var10;

               try {
                  var7 = var6.doSelect(var5, 0, 1);
               } catch (Exception var16) {
                  var16.printStackTrace();
               }

               var9 = var7.getItemValue(0, "deptid");
               var5 = var7.getItemValue(0, "deptname");
            }

            this.setItemValue(var1, "salerid", var10);
            this.setItemValue(var1, "saleropcode", var11);
            this.setItemValue(var1, "salername", var12);
            this.setItemValue(var1, "salesdeptname", var5);
            this.setItemValue(var1, "salesdeptid", var9);
         }

         var9 = "1";
         if ((var20 = NpbusiDBHelper.getCustomDefinfo(var8, var4)) != null && var20.getRowCount() > 0) {
            var9 = var20.getItemValue(0, "delivermethod");
            var11 = var20.getItemValue(0, "settletypeid");
            var12 = var20.getItemValue(0, "lowpriceflag");
            if (var11 == null || var11.equals("")) {
               var11 = ((Bms_sales_mde)this.mdemodel).getApvalue("结算方式");
            }

            this.setItemValue(var1, "settletypeid", var11);
            this.setItemValue(var1, "delivermethod", var9);
            this.setItemValue(var1, "lowpriceflag", var12);
            this.on_itemvaluechange(var1, "delivermethod", var9);
         }

         var5 = "select * from BMS_TR_POS_DEF where COMPANYID=" + var4;
         int var23 = 0;

         try {
            var7 = var6.doSelect(var5, 0, 10);
         } catch (Exception var15) {
            var15.printStackTrace();
         }

         if (var7 != null) {
            var23 = var7.getRowCount();
         }

         var12 = "";
         var5 = "";
         var13 = "";
         if (var23 == 1) {
            var12 = var7.getItemValue(0, "tranposid");
            var5 = var7.getItemValue(0, "tranposname");
            var13 = var7.getItemValue(0, "opcode");
         } else if (var23 != 0) {
            Bms_tr_pos_hov var21;
            (var21 = new Bms_tr_pos_hov(true)).setOtherwheres("COMPANYID = " + var4);
            DBTableModel var18;
            if ((var18 = var21.showDialog(this.frame, "")).getRowCount() > 0) {
               var12 = var18.getItemValue(0, "tranposid");
               var5 = var18.getItemValue(0, "tranposname");
               var13 = var18.getItemValue(0, "opcode");
            }
         }

         if (var9 != null && var9.equals("1")) {
            this.setItemValue(var1, "targetposid", var12);
            this.setItemValue(var1, "targetname", var5);
            this.setItemValue(var1, "targetposopcode", var13);
         }

         if (var9 != null && var9.equals("0")) {
            this.setItemValue(var1, "midposid", var12);
            this.setItemValue(var1, "midposname", var5);
            this.setItemValue(var1, "midposopcode", var13);
         }

         try {
            if ((var10 = PresHelper.bms_chk_blurpolicy(((Bms_sales_mde)this.mdemodel).getEntryid(), var4)) != null && !var10.equals("")) {
               this.infoMessage("模糊赠协议", var10);
            }
         } catch (Exception var14) {
            var14.printStackTrace();
         }

         String[] var22 = SaCalcRate.getAssessDataForClient(var4);
         this.setItemValue(var1, "setdays", var22[2]);
         this.setItemValue(var1, "awardrate", var22[0]);
         this.setItemValue(var1, "punishrate", var22[1]);
      }

      return super.on_hov(var1, var2, var3);
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3;
      if (var2.equals("saleropcode")) {
         this.getItemValue(var1, "entryid");
         if ((var2 = this.getItemValue(var1, "customid")) != null && !var2.equals("")) {
            if ((var3 = this.getItemValue(var1, "entryid")) != null && !var3.equals("")) {
               return "customid=" + var2 + " and (entryid is null or entryid=" + var3 + ")";
            } else {
               this.infoMessage("提示", "没有独立单元！");
               return "1>2";
            }
         } else {
            this.infoMessage("提示", "请先录入客户！");
            return "1>2";
         }
      } else if (!var2.equals("midposopcode") || (var3 = this.getItemValue(var1, "customid")) != null && !var3.equals("")) {
         if (var2.equals("targetposopcode")) {
            if ((var3 = this.getItemValue(var1, "customid")) != null && !var3.equals("")) {
               return "tranpostype = 1 and companyid = " + var3;
            } else {
               this.infoMessage("提示", "请先录入客户！");
               return "1>2";
            }
         } else if (var2.equals("agentopcode")) {
            var3 = this.getItemValue(var1, "entryid");
            if (!(var2 = this.getItemValue(var1, "customid")).equals("") && var2 != null) {
               return " type=2 and companyid=" + var2 + " and (entryid is null or entryid=" + var3 + ")";
            } else {
               this.infoMessage("提示！", "请选择客户！");
               return " 1>2";
            }
         } else if (var2.equals("agentid")) {
            var3 = this.getItemValue(var1, "entryid");
            return " type=2 and (entryid is null or entryid=" + var3 + ")";
         } else {
            return super.getHovOtherWheres(var1, var2);
         }
      } else {
         this.infoMessage("提示", "请先录入客户！");
         return "1>2";
      }
   }

   protected String getOtherWheres() {
      String var1;
      if ((var1 = ((Bms_sales_mde)this.mdemodel).getEntryid()) != null && var1.length() != 0) {
         var1 = "entryid = " + var1 + " and satypeid = 1";
         return var1 + super.getOtherWheres();
      } else {
         this.infoMessage("提示", "您当前登录的角色没有指定独立单元，不能操作！");
         return null;
      }
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "satypeid", "1");
      Userruninfo var2 = ClientUserManager.getCurrentUser();
      this.setItemValue(var1, "entryid", ((Bms_sales_mde)this.mdemodel).getEntryid());
      this.setItemValue(var1, "entryname", ((Bms_sales_mde)this.mdemodel).getEntryname());
      this.setItemValue(var1, "inputmanid", var2.getUserid());
      this.setItemValue(var1, "inputmanname", var2.getUsername());
      String var3;
      if ((var3 = ((Bms_sales_mde)this.mdemodel).getApvalue("发货保管账集合")) != null && var3.length() != 0) {
         this.setItemValue(var1, "stsetid", var3);
         if ((var3 = ((Bms_sales_mde)this.mdemodel).getApvalue("授权独立单元")) != null && var3.length() != 0) {
            this.setItemValue(var1, "sa_mode", "1");
            if ((var3 = ((Bms_sales_mde)this.mdemodel).getApvalue("配货模式")) != null && !var3.equals("")) {
               this.setItemValue(var1, "fix_mode", var3);
            } else {
               this.setItemValue(var1, "fix_mode", "1");
            }

            if ((var3 = ((Bms_sales_mde)this.mdemodel).getApvalue("结算方式")) != null && !var3.equals("")) {
               this.setItemValue(var1, "settletypeid", var3);
            } else {
               this.setItemValue(var1, "settletypeid", "1");
            }

            this.setItemValue(var1, "approveflag", "0");
            this.setItemValue(var1, "usestatus", "2");
            this.setItemValue(var1, "receiveflag", "0");
            this.setItemValue(var1, "printflag", "0");
            this.setItemValue(var1, "comefrom", "1");
            this.setItemValue(var1, "invtype", "1");
            this.setItemValue(var1, "credate", NpbusiDBHelper.getSysdate());
            this.setItemValue(var1, "assessdate", NpbusiDBHelper.getSysdate());
            return super.on_new(var1);
         } else {
            this.warnMessage("警告", "没有定义授权独立单元，请检查!");
            return -1;
         }
      } else {
         this.warnMessage("警告", "没有定义发货保管帐集合，请检查!");
         return -1;
      }
   }

   protected int on_beforedel(int var1) {
      if (this.getdbStatus(var1) == 1) {
         return 0;
      } else {
         String var2 = this.getItemValue(var1, "usestatus");
         String var3 = this.getItemValue(var1, "approveflag");
         return "2".equals(var2) && "0".equals(var3) ? super.on_beforedel(var1) : -1;
      }
   }

   protected String getEditablecolumns(int var1) {
      String var2 = this.getItemValue(var1, "usestatus");
      String var3 = this.getItemValue(var1, "approveflag");
      String var4;
      if ((var4 = this.getItemValue(var1, "delivermethod")).equals("1")) {
         var4 = ",urgentflag,tranpriority,targetdate,tranmethod,targetposopcode";
      } else if (var4.equals("0")) {
         var4 = ",midposopcode";
      } else {
         var4 = "";
      }

      String var5 = "saleropcode,sa_mode,fix_mode,invtype,settletypeid,delivermethod,fmopcode,memo,assessdate,agentopcode,nowmsflag";
      int var6 = this.mdemodel.getDetailModel().getDBtableModel().getRowCount();
      int var7;
      if ((var7 = this.getdbStatus(var1)) != 1 && "2".equals(var2) && "0".equals(var3)) {
         return var5 + var4;
      } else if (var7 != 1 && (!"2".equals(var2) || !"0".equals(var3))) {
         return "nothing";
      } else if (var7 == 1 && var6 > 0) {
         return var5 + var4;
      } else {
         return var7 == 1 ? var5 + var4 + ",customopcode" : super.getEditablecolumns(var1);
      }
   }

   protected int on_beforemodify(int var1) {
      return super.on_beforemodify(var1);
   }

   public void on_doubleclick(int var1, int var2) {
      this.setFocus("credate");
      super.on_doubleclick(var1, var2);
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3;
      if ((var3 = this.getItemValue(var1, "fmid")) == null || "".equals(var3) || "0".equals(var3)) {
         this.setItemValue(var1, "fmid", "0");
         this.setItemValue(var1, "EXCHANGE", "1");
      }

      return super.on_checkrow(var1, var2);
   }

   protected void setFocus(String var1) {
      super.setFocus(var1);
   }

   public void docPrint(String var1, int var2) {
      String var3 = this.getItemValue(var2, "printflag");
      if (!"1".equals(var3) || JOptionPane.showConfirmDialog(this.frame, "该单据已打印，是否再次打印", "提示", 0) == 0) {
         super.docPrint(var1, var2);
      }
   }
}
